
/**
 * Title:        Appia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia;

import java.util.Vector;

import appia.events.channel.ExternalEvent;

public class Appia {

	Vector eventSchedulers=new Vector();

	///////////////////////////////////////////////
	TimerManager timerManager=null;

  public Appia() {
    timerManager=new TimerManager();
    timerManager.start();
  }

  ///////////////////////////////////////////////
	public static TimerManager getTimerManager() {
		return appia.timerManager;
	}

	public static void setTimerManager(TimerManager timerManager) {
    if (appia.timerManager!=null) {
      appia.timerManager.stop();
    }

    appia.timerManager=timerManager;

    appia.timerManager.start();
	}

	////////////////////////////////////////////////


	private static Appia appia=new Appia();

	public static void insertEventScheduler(EventScheduler eventScheduler) {
    if ( ! appia.eventSchedulers.contains(eventScheduler) )
       appia.eventSchedulers.addElement(eventScheduler);
	}

	public static void removeEventScheduler(EventScheduler eventScheduler) {
		appia.eventSchedulers.removeElement(eventScheduler);
	}

  public static void insertListenRequest(ExternalEvent descriptor) {}
  public static void removeListenREquest(ExternalEvent descriptor) {}

	public static void run() {
    //some final initializations
    int i;

    for (i=0 ; i < appia.eventSchedulers.size() ; i++) {
			EventScheduler es=(EventScheduler)appia.eventSchedulers.elementAt(i);
			es.start();
    }

    i=0;
    boolean consumedEvent;
    EventScheduler es;
		while (true) {

      try {
        es=(EventScheduler)appia.eventSchedulers.elementAt(i);
      } catch (ArrayIndexOutOfBoundsException e) {
        es=null;
      }

      if ( es != null )
        consumedEvent=es.consumeEvent();
      else
        consumedEvent=false;

      synchronized (appia) {
        if ( consumedEvent )
           appia.nEvents--;

        if ( appia.nEvents == 0 ) {
          try {
            appia.wait();
          } catch (InterruptedException e) {}
        }
      }

      i++;
      if ( i >= appia.eventSchedulers.size() ) {
        i=0;
        //so other threads can run
        Thread.yield();
      }
		}
	}

  public static void insertedEvent() {
    synchronized (appia) {
      if ( appia.nEvents == 0 )
         appia.notify();

      appia.nEvents++;
    }
  }

	///////////////////////////////////////////////

  private int nEvents=0;
}