
/**
 * Title:        Appia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.events;

import appia.*;
import appia.message.Message;

public class SendableEvent extends Event {

  public SendableEvent() {
    message=new Message();
  }

  public SendableEvent(Channel channel, Direction dir, Session source) throws AppiaEventException {
    super(channel,dir,source);
    message=new Message();
  }

  public SendableEvent(Message msg) {
    message=msg;
  }

  public SendableEvent(Channel channel, Direction dir, Session source, Message msg) throws AppiaEventException {
    super(channel,dir,source);
    message=msg;
  }

  public Object dest;
  public Object source;

  protected Message message;

  public Message getMessage() {
    return message;
  }

  public void setMessage(Message message) {
    this.message=message;
  }
}