
/**
 * Title:        Appia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.events.channel;

import appia.*;

public class ChannelEvent extends Event {

  private EventQualifier qualifier;

  public ChannelEvent() {
    qualifier=new EventQualifier(EventQualifier.NOTIFY);
  }

  public ChannelEvent(Channel channel, Direction dir, Session source, EventQualifier qualifier)
    throws AppiaEventException {

    super(channel,dir,source);

    if ( qualifier == null )
       throw new AppiaEventException(AppiaEventException.UNKNOWNQUALIFIER,"Unknown EventQualifier given");

    this.qualifier=qualifier;
  }

  public void setQualifier(EventQualifier qualifier) {
    this.qualifier=qualifier;
  }

  public EventQualifier getQualifier() {
    return qualifier;
  }

  public Event cloneEvent() throws CloneNotSupportedException {
    ChannelEvent e=(ChannelEvent)super.cloneEvent();
    e.qualifier=new EventQualifier(qualifier.get());
    return e;
  }

}