
package appia.events.channel;

import java.io.OutputStream;

/**
 * Event for <i>debugging</i> porpuses.
 *
 * @author Alexandre Pinto
 * @version 0.1
 * @see java.io.OutputStream
 */
public class Debug extends ChannelEvent {

  OutputStream stream;

  /**
   * @param stream the {@link java.io.OutputStream OutputStream} where debugging
   *               information will be put.
   */
  public Debug(OutputStream stream) {
    this.stream=stream;
  }

  /**
   * Get the {@link java.io.OutputStream OutputStream} where debugging information
   * will be put.
   * <br>
   *
   * @return the {@link java.io.OutputStream OutputStream}
   */
  public OutputStream getOutput() {
    return stream;
  }
}