
/**
 * Title:        Apia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.message;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

public class AppiaOutputStream extends ByteArrayOutputStream {

  public AppiaOutputStream(int size) {
    super(size);
  }

  public AppiaOutputStream() {
    super();
  }

  public void writeToMsgBuffer(MsgBuffer mbuf) throws IOException {
    if (mbuf.len != count)
       throw new IOException("appia:AppiaOutputStream: MsgBuffer length != this.count");

    System.arraycopy(buf,0,mbuf.data,mbuf.off,count);
    reset();
  }

  private ObjectOutputStream oStream;

  public void writeObjectToMessage(Object obj, Message msg) throws IOException {
    (new ObjectOutputStream(this)).writeObject(obj);

    MsgBuffer mbuf=new MsgBuffer();
    mbuf.len=size();
    msg.push(mbuf);

    System.arraycopy(buf,0,mbuf.data,mbuf.off,mbuf.len);
    reset();
  }
}