
/**
 * Title:        Apia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.protocols.group;

import appia.*;
import appia.protocols.udpsimple.InetWithPort;

public class GroupBottomLayer extends Layer {

  public GroupBottomLayer() {
    try {
      Class gse=Class.forName("appia.protocols.group.events.GroupSendableEvent");
      Class view=Class.forName("appia.protocols.group.events.View");
      Class init=Class.forName("appia.protocols.group.events.GroupInit");
      Class debug=Class.forName("appia.events.channel.Debug");

      evProvide=new Class[0];

      evRequire=new Class[1];
      evRequire[0]=view;

      evAccept=new Class[4];
      evAccept[0]=gse;
      evAccept[1]=view;
      evAccept[2]=init;
      evAccept[3]=debug;

    } catch (ClassNotFoundException ex) {
      throw new AppiaGroupError("GroupBottomLayer: "+ex.getMessage());
    }
  }

  public Session createSession() {
    return new GroupBottomSession(this);
  }
}