
/**
 * Title:        Apia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.protocols.group;

import appia.*;


public class IntraLayer extends Layer {

  public IntraLayer() {
    try {
      Class view=Class.forName("appia.protocols.group.events.View");
      Class fail=Class.forName("appia.protocols.group.events.Fail");
      Class install=Class.forName("appia.protocols.group.events.InstallView");
      Class block=Class.forName("appia.protocols.group.events.Block");
      Class blockok=Class.forName("appia.protocols.group.events.BlockOk");
      Class stabilize=Class.forName("appia.protocols.group.events.Stabilize");
      Class stable=Class.forName("appia.protocols.group.events.Stable");
      Class init=Class.forName("appia.protocols.group.events.GroupInit");
      Class echo=Class.forName("appia.events.channel.EchoEvent");
      Class debug=Class.forName("appia.events.channel.Debug");

      evProvide=new Class[5];
      evProvide[0]=view;
      evProvide[1]=install;
      evProvide[2]=block;
      evProvide[3]=stabilize;
      evProvide[4]=echo;

      evRequire=new Class[3];
      evRequire[0]=blockok;
      evRequire[1]=stable;
      evRequire[2]=init;

      evAccept=new Class[7];
      evAccept[0]=install;
      evAccept[1]=fail;
      evAccept[2]=blockok;
      evAccept[3]=stable;
      evAccept[4]=init;
      evAccept[5]=view;
      evAccept[6]=debug;

    } catch (ClassNotFoundException ex) {
      throw new AppiaGroupError("IntraLayer: "+ex.getMessage());
    }
  }

  public Session createSession() {
    return new IntraSession(this);
  }
}