
/**
 * Title:        Apia<p>
 * Description:  Protocol development and composition framework<p>
 * Copyright:    Copyright (c) Alexandre Pinto & Hugo Miranda & Luis Rodrigues<p>
 * Company:      F.C.U.L.<p>
 * @author Alexandre Pinto & Hugo Miranda & Luis Rodrigues
 * @version 1.0
 */
package appia.protocols.group;

import appia.*;

public class SyncLayer extends Layer {

  public SyncLayer() {
    try {
      Class block=Class.forName("appia.protocols.group.events.Block");
      Class blockok=Class.forName("appia.protocols.group.events.BlockOk");
      Class view=Class.forName("appia.protocols.group.events.View");
      Class echo=Class.forName("appia.events.channel.EchoEvent");
      Class fail=Class.forName("appia.protocols.group.events.Fail");

      evProvide=new Class[3];
      evProvide[0]=block;
      evProvide[1]=blockok;
      evProvide[2]=echo;

      evRequire=new Class[1];
      evRequire[0]=view;

      evAccept=new Class[4];
      evAccept[0]=block;
      evAccept[1]=blockok;
      evAccept[2]=view;
      evAccept[3]=fail;

    } catch (ClassNotFoundException e) {
      throw new AppiaGroupError("SyncLayer:"+e.getMessage());
    }
  }

  public Session createSession() {
    return new SyncSession(this);
  }
}