
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package appia.protocols.group.events;

import appia.message.*;
import java.io.*;

public class ObjectsMessage extends Message {

  public static final int INIT_SIZE=10;
  public static final int FACTOR=2;

  private Object[] objs=new Object[INIT_SIZE];
  private int pos=0;

  public void push(Object obj) {

    if (pos == objs.length) {
      Object[] aux=new Object[FACTOR*objs.length];
      System.arraycopy(objs,0,aux,0,pos);
      objs=aux;
    }

    objs[pos]=obj;
    pos++;
  }

  public Object pop() {

    if (pos == 0) {
      MsgBuffer mbuf=new MsgBuffer();
      mbuf.len=super.length();
      super.peek(mbuf);

      ais.setByteArray(mbuf.data,mbuf.off,mbuf.len);

      try {
        ObjectInputStream ois=new ObjectInputStream(ais);

        objs=(Object[])ois.readObject();
        pos=ois.readInt();
      } catch (Exception ex) {
        ex.printStackTrace();
        return null;
      }

      super.discard(mbuf.len - ais.available());
    }

    pos--;
    Object obj=objs[pos];
    objs[pos]=null;

    if ((objs.length > INIT_SIZE) && (pos == (objs.length/(FACTOR*2)))) {
      Object[] aux=new Object[objs.length/FACTOR];
      System.arraycopy(objs,0,aux,0,pos);
      objs=aux;
    }

    return obj;
  }

  public void flush() throws IOException {

    aos.reset();
    ObjectOutputStream oos=new ObjectOutputStream(aos);

    oos.writeObject(objs);
    oos.writeInt(pos);
    oos.close();

    MsgBuffer mbuf=new MsgBuffer();
    mbuf.len=aos.size();
    super.push(mbuf);

    aos.readByteArray(mbuf.data,mbuf.off,mbuf.len);

    while (pos > 0) {
      pos--;
      objs[pos]=null;
    }
  }

  public Object clone() {
    byte[] data=super.toByteArray();
    ObjectsMessage omsg=new ObjectsMessage();
    omsg.setByteArray(data,0,data.length);
    omsg.objs=(Object[])objs.clone();
    omsg.pos=pos;
    return omsg;
  }

  // Redefenitions


  // Auxiliary classes

  private class AuxOutputStream extends ByteArrayOutputStream {

    public int readByteArray(byte[] buf, int off, int len) {
      int r=Math.min(count,len);
      System.arraycopy(this.buf,0,buf,off,r);
      return r;
    }
  }

  private class AuxInputStream extends ByteArrayInputStream {

    public AuxInputStream() {
      super(new byte[0]);
    }

    public void setByteArray(byte[] buf, int off, int len) {
      super.buf=buf;
      super.count=len+off;
      super.pos=off;
      super.mark=off;
    }
  }

  private AuxInputStream ais=new AuxInputStream();
  private AuxOutputStream aos=new AuxOutputStream();
}