package appia.protocols.sendEcho;

//////////////////////////////////////////////////////////////////////
//                                                                  //
// Appia: protocol development and composition framework            //
//                                                                  //
// Version: 1.0/J                                                   //
//                                                                  //
// Copyright, 2000, Universidade de Lisboa                          //
// All rights reserved                                              //
// See license.txt for further information                          //
//                                                                  //
// Class: HASession: Handle All Session              //
//                                                                  //
// Author: Hugo Miranda, 05/2000                                    //
//                                                                  //
// Change Log:                                                      //
// Data, alteracao, razao/consequncias                             //
//                                                                  //
//////////////////////////////////////////////////////////////////////

import appia.*;
import appia.events.channel.*;

public class SendEchoSession extends Session {

    long acum;
    long count;

    /**
     * Mainly used for corresponding layer initialization
     */

    public SendEchoSession(Layer l) {
	super(l);
    }

    /**
     * This protocol does not attempt to bind any sessions on channels
     */

    public void boundSessions(Channel channel) {
    }

    /**
     * Main Event handler function. Accepts all incoming events and
     * forwards them
     * @ params e The incoming event
     * @ see Session
     */

    public void handle(Event e) {
	if(e instanceof appia.events.channel.ChannelInit) {
	    count=1;
	    try {
		e.go();
	    }
	    catch(AppiaEventException ex) {}
    	    sendEcho(e);
        }
	else if(e instanceof SendEchoEvent) {
	    acum+=System.currentTimeMillis()-((SendEchoEvent)e).timeSent;
	    if(count<10000) {
		sendEcho(e);
		count++;
	    }
	    else {
		System.out.println("Acabou. Tempo: "+acum+"ms");
	    }
	}
    }
	
    public Layer getLayer() {
	return layer;
    }

    private void sendEcho(Event e) {
	try {
	    SendEchoEvent see=new SendEchoEvent();
	    EchoEvent ee=new EchoEvent(see, e.getChannel(), 
				       new Direction(Direction.DOWN), this);
	    see.timeSent=System.currentTimeMillis();
	    ee.go();
	}
	catch(AppiaEventException ex) {
	    System.out.println("Excepcao");
	}
    }
}
